#include <stdlib.h>

#include <imsgbox.hpp>

#include "MLESearch.hpp"



MLESearch::MLESearch(IWindow *Par, IWindow *Own,IMultiLineEdit *_edit,int ID):
              IFrameWindow(
                 IResourceId(ID),
                 Par,
                 Own,
                 IRectangle(),
                 dialogBackground|dialogBorder|titleBar,
                 "Search"
              ),
              srchText(
                 _edit->text()
              ),
              edit(
                 _edit
              ),
              Canvas(
                 1,
                 this,
                 this
              ),
              Canvas2(
                 2,
                 &Canvas,
                 &Canvas
              ),
              Find(
                 FindID,
                 &Canvas2,
                 &Canvas2
              ),
              FindNext(
                 FindNextID,
                 &Canvas2,
                 &Canvas2
              ),
              Done(
                 DoneID,
                 &Canvas2,
                 &Canvas2
              ),
              FindTxt(
                 20,
                 &Canvas,
                 &Canvas
              ),
              label(
                 100,
                 &Canvas,
                 &Canvas
              )
{
  CursorPos=StartPos=edit->cursorPosition();
  top=edit->top();

  Find.setText("Find");
  FindNext.setText("Find Next");
  Done.setText("Done");

  FindNext.enable(false);

  label.setText("Find Text:");

  Canvas.addToCell(&label,2,2);
  Canvas.addToCell(&FindTxt,2,4);

  Canvas.addToCell(&Canvas2,2,6);

  IRectangle orect(Own->rect());
  IRectangle rect(orect.minX(),
                  orect.minY(),
                  orect.minX()+Canvas.minimumSize(true).width()+IMultiCellCanvas::defaultCell().width(),
                  orect.minY()+Canvas.minimumSize().height()
                  );

  rect=frameRectFor(rect);

  IPair      c( (orect.width()-rect.width())/2 , (orect.height()-rect.height())/2 );
  orect.shrinkBy(c);

//  IPoint minxy( mapPoint(orect.minXMinY(),Own->handle(),
//                IWindow::desktopWindow()->handle()));

  ISize size( rect.width(),
              rect.height() );

  moveSizeTo(IRectangle(orect.minXMinY(),size ) );

  setClient(&Canvas);
  handleEventsFor(this);

  show();
  showModally();
}


MLESearch::~MLESearch(){
  edit->setCursorPosition(CursorPos);
  edit->setTop(top);
  owner()->setFocus(); //fixes a focus bugaboo in NT when the modal messagebox pops up
}

Boolean MLESearch::command(ICommandEvent &ev){
  switch(ev.commandId()){
     case FindID:
        StartPos=CursorPos;
        fndText=FindTxt.text();
        if(FindFnc())
           FindNext.enable(true);
        else{
           IMessageBox Box(this);
           Box.setTitle("Not Found");
           Box.show("Can't Find "+fndText,IMessageBox::applicationModal|
                           IMessageBox::errorIcon|IMessageBox::moveable|
                           IMessageBox::okButton);
        }

        break;
     case FindNextID:
        if(!FindFnc()){
           FindNext.enable(false);
           IMessageBox Box(this);
           Box.setTitle("Not Found");
           Box.show("Can't Find "+fndText,IMessageBox::applicationModal|
                           IMessageBox::errorIcon|IMessageBox::moveable|
                           IMessageBox::okButton);
        }

        break;
     case DoneID:
        dismiss(ev.commandId());
        break;
     default:
        dismiss(0);
  }
return true;
}

int MLESearch::FindFnc(){

  int Idx=srchText.indexOf(fndText,StartPos);

  if(Idx){
     edit->selectRange(IRange(Idx-1,Idx-1+fndText.length()));
     StartPos=Idx+fndText.length();
     edit->setCursorPosition(Idx-1);
     edit->setTop(edit->cursorLinePosition());
  }

return Idx!=0;
}
